"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.safeFetchAddressLookupTableFromSeeds = exports.fetchAddressLookupTableFromSeeds = exports.findAddressLookupTablePda = exports.getAddressLookupTableGpaBuilder = exports.safeFetchAllAddressLookupTable = exports.fetchAllAddressLookupTable = exports.safeFetchAddressLookupTable = exports.fetchAddressLookupTable = exports.deserializeAddressLookupTable = exports.getAddressLookupTableAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getAddressLookupTableAccountDataSerializer(context) {
    const s = context.serializer;
    return (0, umi_1.mapSerializer)(s.struct([
        ['discriminator', s.u32()],
        ['deactivationSlot', s.u64()],
        ['lastExtendedSlot', s.u64()],
        ['lastExtendedStartIndex', s.u8()],
        ['authority', s.option(s.publicKey(), { fixed: true })],
        ['padding', s.u16()],
        ['addresses', s.array(s.publicKey(), { size: 'remainder' })],
    ], { description: 'AddressLookupTableAccountData' }), (value) => ({ ...value, discriminator: 1, padding: 0 }));
}
exports.getAddressLookupTableAccountDataSerializer = getAddressLookupTableAccountDataSerializer;
function deserializeAddressLookupTable(context, rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getAddressLookupTableAccountDataSerializer(context));
}
exports.deserializeAddressLookupTable = deserializeAddressLookupTable;
async function fetchAddressLookupTable(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'AddressLookupTable');
    return deserializeAddressLookupTable(context, maybeAccount);
}
exports.fetchAddressLookupTable = fetchAddressLookupTable;
async function safeFetchAddressLookupTable(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists
        ? deserializeAddressLookupTable(context, maybeAccount)
        : null;
}
exports.safeFetchAddressLookupTable = safeFetchAddressLookupTable;
async function fetchAllAddressLookupTable(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'AddressLookupTable');
        return deserializeAddressLookupTable(context, maybeAccount);
    });
}
exports.fetchAllAddressLookupTable = fetchAllAddressLookupTable;
async function safeFetchAllAddressLookupTable(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeAddressLookupTable(context, maybeAccount));
}
exports.safeFetchAllAddressLookupTable = safeFetchAllAddressLookupTable;
function getAddressLookupTableGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('splAddressLookupTable', 'AddressLookupTab1e1111111111111111111111111');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        discriminator: [0, s.u32()],
        deactivationSlot: [4, s.u64()],
        lastExtendedSlot: [12, s.u64()],
        lastExtendedStartIndex: [20, s.u8()],
        authority: [21, s.option(s.publicKey(), { fixed: true })],
        padding: [54, s.u16()],
        addresses: [56, s.array(s.publicKey(), { size: 'remainder' })],
    })
        .deserializeUsing((account) => deserializeAddressLookupTable(context, account))
        .whereField('discriminator', 1);
}
exports.getAddressLookupTableGpaBuilder = getAddressLookupTableGpaBuilder;
function findAddressLookupTablePda(context, seeds) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('splAddressLookupTable', 'AddressLookupTab1e1111111111111111111111111');
    return context.eddsa.findPda(programId, [
        s.publicKey().serialize(seeds.authority),
        s.u64().serialize(seeds.recentSlot),
    ]);
}
exports.findAddressLookupTablePda = findAddressLookupTablePda;
async function fetchAddressLookupTableFromSeeds(context, seeds, options) {
    return fetchAddressLookupTable(context, findAddressLookupTablePda(context, seeds), options);
}
exports.fetchAddressLookupTableFromSeeds = fetchAddressLookupTableFromSeeds;
async function safeFetchAddressLookupTableFromSeeds(context, seeds, options) {
    return safeFetchAddressLookupTable(context, findAddressLookupTablePda(context, seeds), options);
}
exports.safeFetchAddressLookupTableFromSeeds = safeFetchAddressLookupTableFromSeeds;
//# sourceMappingURL=addressLookupTable.js.map