"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMintSize = exports.getMintGpaBuilder = exports.safeFetchAllMint = exports.fetchAllMint = exports.safeFetchMint = exports.fetchMint = exports.deserializeMint = exports.getMintAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getMintAccountDataSerializer(context) {
    const s = context.serializer;
    return s.struct([
        [
            'mintAuthority',
            s.option(s.publicKey(), { prefix: s.u32(), fixed: true }),
        ],
        ['supply', s.u64()],
        ['decimals', s.u8()],
        ['isInitialized', s.bool()],
        [
            'freezeAuthority',
            s.option(s.publicKey(), { prefix: s.u32(), fixed: true }),
        ],
    ], { description: 'MintAccountData' });
}
exports.getMintAccountDataSerializer = getMintAccountDataSerializer;
function deserializeMint(context, rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getMintAccountDataSerializer(context));
}
exports.deserializeMint = deserializeMint;
async function fetchMint(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Mint');
    return deserializeMint(context, maybeAccount);
}
exports.fetchMint = fetchMint;
async function safeFetchMint(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists ? deserializeMint(context, maybeAccount) : null;
}
exports.safeFetchMint = safeFetchMint;
async function fetchAllMint(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Mint');
        return deserializeMint(context, maybeAccount);
    });
}
exports.fetchAllMint = fetchAllMint;
async function safeFetchAllMint(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeMint(context, maybeAccount));
}
exports.safeFetchAllMint = safeFetchAllMint;
function getMintGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        mintAuthority: [
            0,
            s.option(s.publicKey(), { prefix: s.u32(), fixed: true }),
        ],
        supply: [36, s.u64()],
        decimals: [44, s.u8()],
        isInitialized: [45, s.bool()],
        freezeAuthority: [
            46,
            s.option(s.publicKey(), { prefix: s.u32(), fixed: true }),
        ],
    })
        .deserializeUsing((account) => deserializeMint(context, account))
        .whereSize(82);
}
exports.getMintGpaBuilder = getMintGpaBuilder;
function getMintSize() {
    return 82;
}
exports.getMintSize = getMintSize;
//# sourceMappingURL=mint.js.map