"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getMultisigSize = exports.getMultisigGpaBuilder = exports.safeFetchAllMultisig = exports.fetchAllMultisig = exports.safeFetchMultisig = exports.fetchMultisig = exports.deserializeMultisig = exports.getMultisigAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
function getMultisigAccountDataSerializer(context) {
    const s = context.serializer;
    return s.struct([
        ['m', s.u8()],
        ['n', s.u8()],
        ['isInitialized', s.bool()],
        ['signers', s.array(s.publicKey(), { size: 11 })],
    ], { description: 'MultisigAccountData' });
}
exports.getMultisigAccountDataSerializer = getMultisigAccountDataSerializer;
function deserializeMultisig(context, rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getMultisigAccountDataSerializer(context));
}
exports.deserializeMultisig = deserializeMultisig;
async function fetchMultisig(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Multisig');
    return deserializeMultisig(context, maybeAccount);
}
exports.fetchMultisig = fetchMultisig;
async function safeFetchMultisig(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists
        ? deserializeMultisig(context, maybeAccount)
        : null;
}
exports.safeFetchMultisig = safeFetchMultisig;
async function fetchAllMultisig(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Multisig');
        return deserializeMultisig(context, maybeAccount);
    });
}
exports.fetchAllMultisig = fetchAllMultisig;
async function safeFetchAllMultisig(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeMultisig(context, maybeAccount));
}
exports.safeFetchAllMultisig = safeFetchAllMultisig;
function getMultisigGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        m: [0, s.u8()],
        n: [1, s.u8()],
        isInitialized: [2, s.bool()],
        signers: [3, s.array(s.publicKey(), { size: 11 })],
    })
        .deserializeUsing((account) => deserializeMultisig(context, account))
        .whereSize(355);
}
exports.getMultisigGpaBuilder = getMultisigGpaBuilder;
function getMultisigSize() {
    return 355;
}
exports.getMultisigSize = getMultisigSize;
//# sourceMappingURL=multisig.js.map