"use strict";
/**
 * This code was AUTOGENERATED using the kinobi library.
 * Please DO NOT EDIT THIS FILE, instead use visitors
 * to add features, then rerun kinobi to update it.
 *
 * @see https://github.com/metaplex-foundation/kinobi
 */
Object.defineProperty(exports, "__esModule", { value: true });
exports.getTokenSize = exports.getTokenGpaBuilder = exports.safeFetchAllToken = exports.fetchAllToken = exports.safeFetchToken = exports.fetchToken = exports.deserializeToken = exports.getTokenAccountDataSerializer = void 0;
const umi_1 = require("@metaplex-foundation/umi");
const types_1 = require("../types");
function getTokenAccountDataSerializer(context) {
    const s = context.serializer;
    return s.struct([
        ['mint', s.publicKey()],
        ['owner', s.publicKey()],
        ['amount', s.u64()],
        ['delegate', s.option(s.publicKey(), { prefix: s.u32(), fixed: true })],
        ['state', (0, types_1.getTokenStateSerializer)(context)],
        ['isNative', s.option(s.u64(), { prefix: s.u32(), fixed: true })],
        ['delegatedAmount', s.u64()],
        [
            'closeAuthority',
            s.option(s.publicKey(), { prefix: s.u32(), fixed: true }),
        ],
    ], { description: 'TokenAccountData' });
}
exports.getTokenAccountDataSerializer = getTokenAccountDataSerializer;
function deserializeToken(context, rawAccount) {
    return (0, umi_1.deserializeAccount)(rawAccount, getTokenAccountDataSerializer(context));
}
exports.deserializeToken = deserializeToken;
async function fetchToken(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    (0, umi_1.assertAccountExists)(maybeAccount, 'Token');
    return deserializeToken(context, maybeAccount);
}
exports.fetchToken = fetchToken;
async function safeFetchToken(context, publicKey, options) {
    const maybeAccount = await context.rpc.getAccount(publicKey, options);
    return maybeAccount.exists ? deserializeToken(context, maybeAccount) : null;
}
exports.safeFetchToken = safeFetchToken;
async function fetchAllToken(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts.map((maybeAccount) => {
        (0, umi_1.assertAccountExists)(maybeAccount, 'Token');
        return deserializeToken(context, maybeAccount);
    });
}
exports.fetchAllToken = fetchAllToken;
async function safeFetchAllToken(context, publicKeys, options) {
    const maybeAccounts = await context.rpc.getAccounts(publicKeys, options);
    return maybeAccounts
        .filter((maybeAccount) => maybeAccount.exists)
        .map((maybeAccount) => deserializeToken(context, maybeAccount));
}
exports.safeFetchAllToken = safeFetchAllToken;
function getTokenGpaBuilder(context) {
    const s = context.serializer;
    const programId = context.programs.getPublicKey('splToken', 'TokenkegQfeZyiNwAJbNbGKPFXCWuBvf9Ss623VQ5DA');
    return (0, umi_1.gpaBuilder)(context, programId)
        .registerFields({
        mint: [0, s.publicKey()],
        owner: [32, s.publicKey()],
        amount: [64, s.u64()],
        delegate: [72, s.option(s.publicKey(), { prefix: s.u32(), fixed: true })],
        state: [108, (0, types_1.getTokenStateSerializer)(context)],
        isNative: [109, s.option(s.u64(), { prefix: s.u32(), fixed: true })],
        delegatedAmount: [121, s.u64()],
        closeAuthority: [
            129,
            s.option(s.publicKey(), { prefix: s.u32(), fixed: true }),
        ],
    })
        .deserializeUsing((account) => deserializeToken(context, account))
        .whereSize(165);
}
exports.getTokenGpaBuilder = getTokenGpaBuilder;
function getTokenSize() {
    return 165;
}
exports.getTokenSize = getTokenSize;
//# sourceMappingURL=token.js.map